import 'dart:async';

abstract class StreamManager<D, M> {
  StreamManager(D api, M model) : _api = api, _model = model;
  final StreamController<M> _streamController = StreamController<M>.broadcast();
  Stream<M> get stream => _streamController.stream;
  M _model;
  D _api;
  D get api => _api;

  bool _isDirty;

  M get model => _model;
  set model(M newModel) {
    _model = newModel;
    _isDirty = true;
  }

  void update(M model) {
    _model = model;
    _isDirty = false;
    _streamController.sink.add(_model);
  }

  void dispose() {
    _streamController?.close();
  }
}